# -*- coding: utf-8 -*-
from Tkinter import *
import tkFileDialog, tkMessageBox, tkSimpleDialog
from visual import *
import thread

#Ve 3D zobrazení se věž otáčí stiskem a táhnutím pravého tlačítka myši

barvy_rgb = {"a":(0,255,255), "r":(255, 0, 0), "g":(0, 255, 0), "b":(0, 0, 255), "y":(255, 255, 0)}
barvy_hex = {"a":"#00FFFF", "r":"#FF0000", "g":"#00FF00", "b":"#0000FF", "y":"#FFFF00"}






class Kostka:
    def __init__(self):
        pass


class App:
    def __init__(self):
        self.root = Tk()

        button_frame = Frame(self.root)
        button_frame.pack(fill=X)
        Button(button_frame, text="Otevřít Soubor", command=self.otevrit_soubor).pack(side=LEFT)
        Button(button_frame, text="Rekapitulace", command=self.rekapitulace).pack(side=LEFT)
        Button(button_frame, text="Zobrazit patro", command=self.zobrazit_patro).pack(side=LEFT)
        Button(button_frame, text="Zobrazit stranu", command=self.zobrazit_stranu).pack(side=LEFT)
        Button(button_frame, text="Zobrazit ve 3D", command=self.zobrazit_ve_3d).pack(side=LEFT)
        
#        Button(button_frame, text="Zobrazit ve 3D řez patra", command=self.zobrazit_ve_3d_patro).pack(side=LEFT)
        
        self.canvas = Canvas(self.root, width=600, height=600, background="white")
        self.canvas.pack(fill=X)
        self.data = []
        self.kostky_patra = {}

        self.root.mainloop()


    def otevrit_soubor(self):
        self.data = []
        self.kostky_patra = {}
        f = open(tkFileDialog.askopenfilename(), "rU")
 #       f = open("specifikace-01.99", "rU")
        data = f.read().strip().split("\n")
        prvni_radek = data[0].split()

        self.vez_rozmer_x = int(prvni_radek[0])
        self.vez_rozmer_y = int(prvni_radek[1])
        self.typ = prvni_radek[2]

        
        for radek in data[1:]:
            radek = radek.lower().strip().split()
            if len(radek) != 5:
                continue
            kostka = Kostka()
            kostka.patro, kostka.x, kostka.y, kostka.barva, kostka.rozmery = int(radek[0]), int(radek[1]), int(radek[2]), radek[3], tuple(map(lambda x: int(x), radek[4].split("x")))
            self.data.append(kostka)
            
            if kostka.patro not in self.kostky_patra:
                self.kostky_patra[kostka.patro] = [kostka]
            else:
                self.kostky_patra[kostka.patro].append(kostka)
            self.vyska_veze = len(self.kostky_patra)




    def rekapitulace(self):
        kostky_barvy = {}
        kostky_rozmery = {}
        for kostka in self.data:
            if kostka.barva not in kostky_barvy:
                kostky_barvy[kostka.barva] = 1
            else:
                kostky_barvy[kostka.barva] += 1

            rozmer = tuple(sorted(list(kostka.rozmery)))

            if rozmer not in kostky_rozmery:
                kostky_rozmery[rozmer] = 1
            else:
                kostky_rozmery[rozmer] += 1

        
        
        info = "Barva: počet kostek\n"
        for barva in kostky_barvy:
            info += barva + ": " + str(kostky_barvy[barva]) + "\n"
        info += "\n"
        
        info += "Rozměr: počet kostek\n"
        for rozmer in kostky_rozmery:
            info += "X".join(map(lambda x: str(x), rozmer)) + ": " + str(kostky_rozmery[rozmer]) + "\n"

        tkMessageBox.showinfo("Rekapitulace", info)

    
    def zobrazit_patro(self):
        cislo_patra = tkSimpleDialog.askinteger("Patro", "Zadejte číslo patra, které chcete zobrazit")

        self.canvas.delete(ALL)
        if cislo_patra and cislo_patra in self.kostky_patra:
            for kostka in self.kostky_patra[cislo_patra]:
                self.canvas.create_rectangle((kostka.x-1)*30, (kostka.y-1)*30, (kostka.x+kostka.rozmery[0]-1)*30, (kostka.y+kostka.rozmery[1]-1)*30, fill=barvy_hex[kostka.barva], width=4)
                

    def zobrazit_stranu(self):
        strana = tkSimpleDialog.askstring("Strana", "Zadejte stranu věže, kterou chcete zobrazit (N, E, S, W):")
        if strana:
            strana = strana.lower().strip()    

        self.canvas.delete(ALL)
        for kostka in self.data:
            if strana == "w":
                if kostka.x == 1:
                    self.canvas.create_rectangle((kostka.y+20)*6, (100-kostka.patro)*6, (kostka.y+kostka.rozmery[1]+20)*6, (101-kostka.patro)*6, fill=barvy_hex[kostka.barva])
                    
            elif strana == "n":
                if kostka.y == 1:
                    self.canvas.create_rectangle(400-(kostka.x)*6, (100-kostka.patro)*6, 400-(kostka.x+kostka.rozmery[0])*6, (101-kostka.patro)*6, fill=barvy_hex[kostka.barva], width=1)
                
            elif strana == "s":
                if kostka.y+kostka.rozmery[1]-1 == self.vez_rozmer_y:
                    self.canvas.create_rectangle((kostka.x+20)*6, (100-kostka.patro)*6, (kostka.x+kostka.rozmery[0]+20)*6, (101-kostka.patro)*6, fill=barvy_hex[kostka.barva], width=1)
                    
            elif strana == "e":
                if kostka.x+kostka.rozmery[0]-1 == self.vez_rozmer_x:
                    self.canvas.create_rectangle(400-(kostka.y)*6, (100-kostka.patro)*6, 400-(kostka.y+kostka.rozmery[1])*6, (101-kostka.patro)*6, fill=barvy_hex[kostka.barva], width=1)


        
    def zobrazit_ve_3d(self):
        for kostka in self.data:
            box(pos=(kostka.x+(kostka.rozmery[0]/2.),kostka.patro,kostka.y+(kostka.rozmery[1]/2.)), length=kostka.rozmery[0], height=1, width=kostka.rozmery[1], color=barvy_rgb[kostka.barva])
            
        
        

a = App()

            
            
